﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace task01.Context;

public partial class User11Context : DbContext
{
    public User11Context()
    {
    }

    public User11Context(DbContextOptions<User11Context> options)
        : base(options)
    {
    }

    public virtual DbSet<DayStatus> DayStatuses { get; set; }

    public virtual DbSet<Department> Departments { get; set; }

    public virtual DbSet<Dependent> Dependents { get; set; }

    public virtual DbSet<Employee> Employees { get; set; }

    public virtual DbSet<EmployeeStatus> EmployeeStatuses { get; set; }

    public virtual DbSet<Office> Offices { get; set; }

    public virtual DbSet<Profession> Professions { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see https://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=45.67.56.214;Port=5421;Database=user11;Username=user11;password=JSZHJyg1");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<DayStatus>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("daystatus_pk");

            entity.ToTable("day_status", "task1");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Day)
                .HasColumnType("character varying")
                .HasColumnName("day");
        });

        modelBuilder.Entity<Department>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("departments_pk");

            entity.ToTable("departments", "task1");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Description)
                .HasColumnType("character varying")
                .HasColumnName("description");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
            entity.Property(e => e.Supervisorid).HasColumnName("supervisorid");

            entity.HasOne(d => d.Supervisor).WithMany(p => p.Departments)
                .HasForeignKey(d => d.Supervisorid)
                .HasConstraintName("departments_employee_fk");
        });

        modelBuilder.Entity<Dependent>(entity =>
        {
            entity
                .HasNoKey()
                .ToTable("dependent", "task1");

            entity.Property(e => e.Firstid).HasColumnName("firstid");
            entity.Property(e => e.Secondid).HasColumnName("secondid");

            entity.HasOne(d => d.First).WithMany()
                .HasForeignKey(d => d.Firstid)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("dependent_departments_fk");

            entity.HasOne(d => d.Second).WithMany()
                .HasForeignKey(d => d.Secondid)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("dependent_departments_fk_1");
        });

        modelBuilder.Entity<Employee>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("employee_pk");

            entity.ToTable("employee", "task1");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Birthday).HasColumnName("birthday");
            entity.Property(e => e.Departmentid).HasColumnName("departmentid");
            entity.Property(e => e.Email)
                .HasColumnType("character varying")
                .HasColumnName("email");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
            entity.Property(e => e.Officeid).HasColumnName("officeid");
            entity.Property(e => e.Patronymic)
                .HasColumnType("character varying")
                .HasColumnName("patronymic");
            entity.Property(e => e.Phone)
                .HasColumnType("character varying")
                .HasColumnName("phone");
            entity.Property(e => e.Proffesionid).HasColumnName("proffesionid");
            entity.Property(e => e.Surname)
                .HasColumnType("character varying")
                .HasColumnName("surname");

            entity.HasOne(d => d.Department).WithMany(p => p.Employees)
                .HasForeignKey(d => d.Departmentid)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("employee_departments_fk");

            entity.HasOne(d => d.Office).WithMany(p => p.Employees)
                .HasForeignKey(d => d.Officeid)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("employee_kabinet_fk");

            entity.HasOne(d => d.Proffesion).WithMany(p => p.Employees)
                .HasForeignKey(d => d.Proffesionid)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("employee_post_fk");
        });

        modelBuilder.Entity<EmployeeStatus>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("employeestatus_pk");

            entity.ToTable("employee_status", "task1");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Day).HasColumnName("day");
            entity.Property(e => e.Employeeid).HasColumnName("employeeid");
            entity.Property(e => e.Eventid).HasColumnName("eventid");
            entity.Property(e => e.Statusid).HasColumnName("statusid");

            entity.HasOne(d => d.Employee).WithMany(p => p.EmployeeStatuses)
                .HasForeignKey(d => d.Employeeid)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("employeestatus_employee_fk");

            entity.HasOne(d => d.Status).WithMany(p => p.EmployeeStatuses)
                .HasForeignKey(d => d.Statusid)
                .HasConstraintName("employeestatus_daystatus_fk");
        });

        modelBuilder.Entity<Office>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("kabinet_pk");

            entity.ToTable("office", "task1");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Title)
                .HasColumnType("character varying")
                .HasColumnName("title");
        });

        modelBuilder.Entity<Profession>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("post_pk");

            entity.ToTable("profession", "task1");

            entity.Property(e => e.Id).HasColumnName("id");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
