using System;
using System.Collections.Generic;
using System.Linq;
using Avalonia.Controls;
using Avalonia.Interactivity;
using task01.Context;

namespace task01;

public partial class ShowWindow : Window
{
    private Employee _employee;
    private List<Department> _departments;
    private List<Profession> _professions;

    public ShowWindow(Employee employee, List<Department> departments, List<Profession> professions)
    {
        InitializeComponent();
        this._employee = employee;
        this._departments = departments;
        this._professions = professions;

        LoadData();
    }

    private void LoadData()
    {
        NameTextBox.Text = _employee.Name;
        SurnameTextBox.Text = _employee.Surname;
        PatronymicTextBox.Text = _employee.Patronymic;
        PhoneTextBox.Text = _employee.Phone;
        BirthdayTextBox.Text = _employee.Birthday.ToString();
        ProfessionTextBox.Text = _employee.Proffesion?.Name ?? " ";
        DepartmentTextBox.Text = _departments
            .FirstOrDefault(d => d.Id == _employee.Departmentid)?.Name ?? " ";
        EmailTextBox.Text = _employee.Email;
        OfficeTextBox.Text = _employee.Office?.Title ?? " ";
    }

    private void EditButton_Click(object sender, RoutedEventArgs e)
    {
        var editWindow = new EditWindow(_employee, _departments, _professions);
        editWindow.Show();
        Close();
    }

    private void BackButton_Click(object sender, RoutedEventArgs e)
    {
        var mainWindow = new MainWindow();
        mainWindow.Show();
        Close();
    }
}